diff --git a/.project b/.project
index 8f82ddb..bef8b0e 100644
--- a/.project
+++ b/.project
@@ -1,11 +1,11 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<projectDescription>
-	<name>html5Widgets.old</name>
-	<comment></comment>
-	<projects>
-	</projects>
-	<buildSpec>
-	</buildSpec>
-	<natures>
-	</natures>
-</projectDescription>
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>html5Widgets</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+	</buildSpec>
+	<natures>
+	</natures>
+</projectDescription>
diff --git a/shared/js/autocomplete/CVS/Entries b/shared/js/autocomplete/CVS/Entries
new file mode 100644
index 0000000..137a7d4
--- /dev/null
+++ b/shared/js/autocomplete/CVS/Entries
@@ -0,0 +1,3 @@
+/index.html/1.1/Tue Jun  1 04:46:08 2010//
+D/turnOffInExplorer////
+D/xml////
diff --git a/shared/js/autocomplete/CVS/Repository b/shared/js/autocomplete/CVS/Repository
new file mode 100644
index 0000000..4f38a0f
--- /dev/null
+++ b/shared/js/autocomplete/CVS/Repository
@@ -0,0 +1 @@
+screengenerator/htdocs/tests/autocomplete
diff --git a/shared/js/autocomplete/CVS/Root b/shared/js/autocomplete/CVS/Root
new file mode 100644
index 0000000..6c6a1d0
--- /dev/null
+++ b/shared/js/autocomplete/CVS/Root
@@ -0,0 +1 @@
+:pserver:tv@192.168.2.25:/home/tv/cvs
diff --git a/shared/js/autocomplete/autocomplete.js b/shared/js/autocomplete/autocomplete.js
new file mode 100644
index 0000000..e7e1acd
--- /dev/null
+++ b/shared/js/autocomplete/autocomplete.js
@@ -0,0 +1,387 @@
+var autocomplete = new function () { 
+	var me = this;
+
+	var inputNodes;
+	var listContainerNode;
+	var bodyNode;
+	var minLength;
+	var req;
+	var currentLookupString = "";
+	var currentFocusedInputNode = null;
+	var numberCurrentValues;
+	
+	var lastLookupString ="", lastLookupValues;
+
+	me.values = null;
+	me.x = -1;
+	me.y = -1;
+	
+	me.init = function () {
+		
+		if (EventHelpers.hasPageLoadHappened(arguments)) return;
+		
+		bodyNode = document.getElementsByTagName('body')[0];
+		minLength = config.getIntegerValue('autocomplete.values.minLength', 0);
+		createListContainerNode();
+		setInitialEvents();
+	}
+	
+	function createListContainerNode () {
+		
+			
+		listContainerNode = document.createElement('div');
+		
+		listContainerNode.style.display = 'none';
+		listContainerNode.style.position= 'absolute';
+		listContainerNode.id = 'autocomplete-selection'
+		
+
+		bodyNode.appendChild(listContainerNode);
+		
+	}
+	
+	function setInitialEvents () {
+		inputNodes = CSSHelpers.getElementsByClassName(document, 
+			'autocomplete_input');
+			
+		for (var i=0; i<inputNodes.length; i++) {
+			
+			EventHelpers.addEvent(inputNodes[i], 'keyup', keyUpEvent);
+			EventHelpers.addEvent(inputNodes[i], 'keypress', keyPressEvent);
+			formNode = DOMHelpers.getAncestorByTagName(inputNodes[i], 'form');
+			turnOffNativeAutocomplete(formNode);
+		}
+		
+		EventHelpers.addEvent(bodyNode, 'click', hideAutocompleteBox);
+		EventHelpers.addEvent(document, 'click', hideAutocompleteBox)
+	}
+	
+	function keyUpEvent(e) {
+		var key = EventHelpers.getKey(e);
+		currentFocusedInputNode = EventHelpers.getEventTarget(e);
+		 switch (key) {
+			case CharCode.DOWN:
+				moveFocusOnListEvent(e);
+				break;
+			case CharCode.ESC:
+				break;
+			case CharCode.ENTER:
+				EventHelpers.preventDefault(e);
+				break;
+			default: 
+				getListEvent(e);
+		} 
+		
+		//getListEvent(e);
+	}
+	
+	function keyPressEvent(e) {
+		var key = EventHelpers.getKey(e);
+		switch (key) {
+			case CharCode.DOWN:
+				moveFocusOnListEvent(e);
+				EventHelpers.preventDefault(e);
+				break;
+			case CharCode.ENTER:
+				EventHelpers.preventDefault(e);
+				break;
+		}
+		
+	}
+	
+	function moveFocusOnListEvent(e) {
+		activeInputNode = EventHelpers.getEventTarget(e);
+		
+		activeInputNode.blur();
+		
+		var listNode = getListNode();
+		
+		
+		// jslog.debug(listNode.nodeName)
+		var listItemNodes = getListItemNodes();
+		var firstListItemNode;
+		
+		
+		
+		
+		if (listItemNodes.length > 0) {
+			firstListItemNode = listItemNodes[0]
+		} else  {
+			firstListItemNode = listItemNodes;
+		}
+		
+		jslog.debug('firstListItemNode: ' + firstListItemNode.nodeName)
+		
+		if (firstListItemNode) {
+			
+			switch (firstListItemNode.nodeName) {
+				case "OPTION":
+					
+						//listNode.focus();
+						//jslog.debug(DebugHelpers.getProperties(firstListItemNode));
+						firstListItemNode.selected = 'selected';
+						replaceValue(firstListItemNode);
+						listNode.focus();
+						
+						
+					
+					break;
+			}
+			
+			//firstListItemNode.focus();
+		}
+		
+		
+		
+		
+		
+		//jslog.debug('listNode properties: ' + DebugHelpers.getProperties(listNode))	
+		
+	}
+	
+	
+	
+	function getListEvent(e) {
+		activeInputNode = EventHelpers.getEventTarget(e);
+		currentLookupString=activeInputNode.value;
+		
+		if (currentLookupString.length < minLength) {
+			listContainerNode.innerHTML = "";
+			return;
+		}
+		
+		
+		
+		me.x = CSSHelpers.getAbsoluteLeft(activeInputNode);
+		me.y = CSSHelpers.getAbsoluteTop(activeInputNode) 
+			+ CSSHelpers.getHeight(activeInputNode);
+		
+		
+		var id=activeInputNode.name.replace(/ /g, '_' );
+		
+		
+		var URL = config.getScriptedValue('autocomplete.urls.' + id,
+			{
+				inputID:	id,
+				inputValue:	currentLookupString
+			});
+			
+		listContainerNode.innerHTML = config.getValue('autocomplete.templates.pleaseWait');
+		showAutocompleteBox();
+		
+		
+		/* 
+		 * if this is not the old request with a few letters tacked on, 
+		 * do an httpRequest to this.  Otherwise, do call setValues().
+		 */
+		
+		if (lastLookupString != "" && currentLookupString.toLowerCase().indexOf(lastLookupString.toLowerCase()) == 0) {
+			showDropDown(lastLookupValues);
+		} else {
+			if (req) {
+				req.abort();
+			}
+			req = XMLHelpers.getXMLHttpRequest(URL, getListRequest);
+			
+		}
+		
+	
+	}
+	
+	function getListRequest() {
+		if (!req) {
+			//DebugHelpers.log("XMLHttpRequest was null: exiting");
+			return;
+	    }
+		
+
+
+	    if (req.readyState == ReadyState.COMPLETED) {
+	        // only if "OK"
+
+	        if (req.status == HttpCode.OK) {
+				var values = req.responseText.split('\n');
+				showDropDown(values);
+				lastLookupString=currentLookupString;
+				lastLookupValues=values;
+			}
+		}
+	}
+	
+	function showDropDown(values) {
+				removeAutocompleteBoxEvents();
+				me.setValues(values);
+				jslog.debug(numberCurrentValues)
+				if (numberCurrentValues == 0) {
+					hideAutocompleteBox();
+				} else {
+					jslog.debug('not zeri')
+					setAutocompleteBoxEvents();
+					showAutocompleteBox();
+				} 
+	}
+	
+	me.setValues = function (values) {
+		me.values = values;
+		
+		var lastElement = me.values.pop();
+		
+		if (lastElement.trim() != "") {
+			me.values.push(lastElement)
+		}
+		
+		
+		if (me.values.length == 0) {
+			listContainerNode.innerHTML = "";
+		}
+		else {
+		
+			var valuesHTMLSb = new StringBuffer();
+			numberCurrentValues = 0;
+			for (var i = 0; i < me.values.length; i++) {
+				var value = me.values[i].trim();
+				
+				if (value != "" && value.toLowerCase().indexOf(currentLookupString.toLowerCase()) == 0 ) {
+					numberCurrentValues++;
+					valuesHTMLSb.append(config.getScriptedValue('autocomplete.templates.listItem', {
+						listItem: me.values[i]
+					}))
+				}
+			}
+			
+			listContainerNode.innerHTML = config.getScriptedValue('autocomplete.templates.list', {
+				listItemsHTML: valuesHTMLSb.toString()
+			});
+		}
+	}
+	
+	function selectKeyEvent (e) {
+		var key = EventHelpers.getKey(e);
+		
+		
+		switch(key){
+			case CharCode.ESC:
+			case CharCode.ENTER:
+				hideAutocompleteBox(e);
+				currentFocusedInputNode.focus();
+				
+				break;
+			case CharCode.TAB:
+				focusOnInputField(e);
+				break;
+			case CharCode.BACKSPACE:
+				currentFocusedInputNode.value = "";
+				hideAutocompleteBox(e);
+				currentFocusedInputNode.focus();
+				// prevents browser from going back a page.
+				EventHelpers.preventDefault(e);
+				break;
+		}
+	}
+	
+	function focusOnInputField(e) {
+		currentFocusedInputNode.focus();
+		if (BrowserDetect.browser == "Explorer") {
+			EventHelpers.preventDefault(e);
+		}
+	}
+	
+	function showAutocompleteBox () {
+		CSSHelpers.moveTo(listContainerNode, me.x, me.y)
+		listContainerNode.style.display = 'block';	
+	}
+	
+	function hideAutocompleteBox(e) {
+		listContainerNode.style.display = 'none';
+		removeAutocompleteBoxEvents();
+		listContainerNode.innerHTML = '';
+	}
+	
+	function getListItemNodes () {
+		var valueNodes = cssQuery(
+			config.getValue('autocomplete.selectors.listItem'),
+			listContainerNode
+		); 
+		
+		return valueNodes;
+	}
+	
+	function getListNode () {
+		var listNodes = cssQuery(
+			config.getValue('autocomplete.selectors.list'),
+			listContainerNode
+		); 
+		
+		if (listNodes && listNodes.length > 0) {
+			return listNodes[0];
+		}
+		else {
+			return null;
+		}
+		
+	}
+	
+	function setAutocompleteBoxEvents() {
+		var valueNodes = getListItemNodes();
+			
+		var listNode = getListNode();
+		
+		if (listNode) {
+			EventHelpers.addEvent(listNode, 'change', replaceValueEvent);
+			EventHelpers.addEvent(listNode, 'blur', hideAutocompleteBox);
+			EventHelpers.addEvent(listNode, 'keyup', selectKeyEvent);
+			EventHelpers.addEvent(listNode, 'keydown', selectKeyEvent);
+			EventHelpers.addEvent(listNode, 'blur', focusOnInputField);
+		}
+		
+		if (valueNodes) {
+			for (var i = 0; i < valueNodes.length; i++) {
+				
+				EventHelpers.addEvent(valueNodes[i], 'click', replaceValueEvent);	
+				
+			}
+		}
+	}
+	
+	function removeAutocompleteBoxEvents() {
+		
+		
+		var valueNodes =  getListItemNodes();
+		
+		var listNode = getListNode();
+		
+		if (listNode) {
+			EventHelpers.removeEvent(listNode, 'change', replaceValueEvent);
+			EventHelpers.removeEvent(listNode, 'blur', hideAutocompleteBox);
+		}
+		
+		if (valueNodes) {
+			for (var i = 0; i < valueNodes.length; i++) {
+				EventHelpers.removeEvent(valueNodes[i], 'click', replaceValueEvent);
+				
+			}
+		}
+	}
+	
+	function replaceValueEvent(e){
+		var valueNode = EventHelpers.getEventTarget(e);
+		replaceValue(valueNode)
+	}
+	 
+	function replaceValue(valueNode) {	
+		var value = valueNode.value;
+		jslog.debug(valueNode.value);
+		if (!value) {
+			value = valueNode.innerHTML;
+		} 
+		
+		activeInputNode.value = value;
+		
+	}
+	
+	function turnOffNativeAutocomplete(formNode) {
+        formNode.setAttribute('autocomplete', 'off');
+    }
+}
+
+EventHelpers.addPageLoadEvent('autocomplete.init'); 
diff --git a/shared/js/autocomplete/turnOffInExplorer/CVS/Entries b/shared/js/autocomplete/turnOffInExplorer/CVS/Entries
new file mode 100644
index 0000000..f2ea187
--- /dev/null
+++ b/shared/js/autocomplete/turnOffInExplorer/CVS/Entries
@@ -0,0 +1 @@
+/index.html/1.1/Tue Jun  1 04:45:15 2010//
diff --git a/shared/js/autocomplete/turnOffInExplorer/CVS/Repository b/shared/js/autocomplete/turnOffInExplorer/CVS/Repository
new file mode 100644
index 0000000..d133da1
--- /dev/null
+++ b/shared/js/autocomplete/turnOffInExplorer/CVS/Repository
@@ -0,0 +1 @@
+screengenerator/htdocs/tests/autocomplete/turnOffInExplorer
diff --git a/shared/js/autocomplete/turnOffInExplorer/CVS/Root b/shared/js/autocomplete/turnOffInExplorer/CVS/Root
new file mode 100644
index 0000000..6c6a1d0
--- /dev/null
+++ b/shared/js/autocomplete/turnOffInExplorer/CVS/Root
@@ -0,0 +1 @@
+:pserver:tv@192.168.2.25:/home/tv/cvs
diff --git a/shared/js/autocomplete/xml/CVS/Entries b/shared/js/autocomplete/xml/CVS/Entries
new file mode 100644
index 0000000..4467fce
--- /dev/null
+++ b/shared/js/autocomplete/xml/CVS/Entries
@@ -0,0 +1 @@
+/config.xml/1.1/Tue Jun  1 04:45:42 2010//
diff --git a/shared/js/autocomplete/xml/CVS/Repository b/shared/js/autocomplete/xml/CVS/Repository
new file mode 100644
index 0000000..8f4188a
--- /dev/null
+++ b/shared/js/autocomplete/xml/CVS/Repository
@@ -0,0 +1 @@
+screengenerator/htdocs/tests/autocomplete/xml
diff --git a/shared/js/autocomplete/xml/CVS/Root b/shared/js/autocomplete/xml/CVS/Root
new file mode 100644
index 0000000..6c6a1d0
--- /dev/null
+++ b/shared/js/autocomplete/xml/CVS/Root
@@ -0,0 +1 @@
+:pserver:tv@192.168.2.25:/home/tv/cvs
diff --git a/shared/js/frequency-decoder.com/slider.js b/shared/js/frequency-decoder.com/slider.js
index d1673b6..74886d8 100644
--- a/shared/js/frequency-decoder.com/slider.js
+++ b/shared/js/frequency-decoder.com/slider.js
@@ -199,6 +199,7 @@ var fdSliderController = (function() {
                 /*@end@*/
         };              
         function fdSlider(options) {
+        	
                 var inp         = options.inp,
                     disabled    = false,
                     tagName     = inp.tagName.toLowerCase(),                      
@@ -206,8 +207,10 @@ var fdSliderController = (function() {
                     max         = +options.range[1], 
                     range       = Math.abs(max - min),
                     inc         = tagName == "select" ? 1 : +options.inc||1,
-                    maxInc      = options.maxInc ? options.maxInc : inc * 2,
-                    precision   = options.inc.search(".") != -1 ? options.inc.substr(options.inc.indexOf(".")+1, options.inc.length - 1).length : 0,
+                    maxInc      = options.maxInc && options.maxInc != 'undefined' ? options.maxInc : inc * 2;
+                   // alert(options.maxInc + "," + maxInc) 
+                    
+                    var precision   = options.inc.search(".") != -1 ? options.inc.substr(options.inc.indexOf(".")+1, options.inc.length - 1).length : 0,
                     steps       = Math.ceil(range / inc),
                     useTween    = !!options.tween,
                     fullARIA    = !!options.fullARIA,
@@ -334,6 +337,7 @@ var fdSliderController = (function() {
                                 maxPx     = vertical ? sH - hH : sW - hW;
                                 stepPx    = maxPx / steps;                                                 
                                 deltaPx   = maxPx / Math.ceil(range / maxInc);
+                                console.log(maxInc)
                                 
                                 sliderW = sW;
                                 sliderH = sH;
diff --git a/shared/js/html5Forms.js b/shared/js/html5Forms.js
new file mode 100644
index 0000000..4551be6
--- /dev/null
+++ b/shared/js/html5Forms.js
@@ -0,0 +1,301 @@
+var html5Forms = new function () {
+	var me = this;
+	
+	var scriptNode = null,
+		scriptDir = null,
+		hasBadValidationImplementation = false; //navigator.userAgent.indexOf('WebKit') > 0,
+		// WebKit less than 534 doesn't show validation UI - we need to check for this (from http://stackoverflow.com/questions/6030522/html5-form-validation-modernizr-safari)
+		hasNativeBubbles = navigator.userAgent.indexOf('WebKit') < 0 || parseInt(navigator.userAgent.match(/AppleWebKit\/([^ ]*)/)[1].split('.')[0])  > 533;
+		
+	
+	var globalEvent = document.addEventListener?document.createEvent("HTMLEvents"):null;
+	
+	
+	
+	me.init = function () {
+		var scriptNodes = document.getElementsByTagName('script');
+		
+		for (var i=0; i<scriptNodes.length; i++) {
+			scriptNode = scriptNodes[i];
+			
+			if (scriptNode.src.match('html5Forms(_src|-p|)\.js')) {
+				scriptNode = scriptNode;
+				scriptDir = getScriptDir();
+				break;
+			}
+		}
+		
+		if (scriptNode) {
+			if (window.yepnope) {
+				var inputSupport = Modernizr.inputtypes;
+				/* let's load the supporting scripts according to what is in data-webforms2-support */
+				var supportArray = scriptNode.getAttribute('data-webforms2-support');
+				var forceJSValidation = (scriptNode.getAttribute('data-webforms2-force-js-validation') == 'true');
+				
+				if (!supportArray) {
+					return;
+				} else if (trim(supportArray) == 'all') {
+					supportArray="validation,number,color,date,ouput,range,placeholder";
+				}
+				
+				supportArray = supportArray.split(',');
+				var toLoad = [];
+				var toRunAfterLoad = [];
+				var loadHTML5Widgets = false;
+				
+				
+				for (var i=0; i<supportArray.length; i++) {
+					var supportReq = trim(supportArray[i]);
+					
+					switch(supportReq) {
+						
+						case "validation":
+						case "autofocus":
+							if (!Modernizr.input.required || hasBadValidationImplementation || forceJSValidation) {
+								
+								toLoad = toLoad.concat([  
+										scriptDir + '../../shared/js/weston.ruter.net/webforms2/webforms2_src.js']);
+								
+								if (supportReq == 'autofocus') {
+									loadHTML5Widgets = true;
+								}
+								
+							}	
+							break;
+						case "number":
+							if (!inputSupport.number) {
+								toLoad = toLoad.concat([
+										scriptDir + '../../shared/css/number.css']);
+								loadHTML5Widgets = true;
+							}
+							break;
+						case "color":
+							if (!inputSupport.color) {
+								
+								toLoad = toLoad.concat([  scriptDir + '../../shared/js/jscolor/jscolor.js']);
+								
+								loadHTML5Widgets = true;
+							}	
+							break;
+						
+						case "datetime":
+						case "date":
+							var lang = scriptNode.getAttribute('data-lang');
+							
+							
+							/* If data-lang is not set, or is set to an unsupported language, use English by default. */
+							if (!lang || 
+								!lang.match(/^(af|al|bg|big5|br|ca|cn|cs|da|de|du|el|en|es|fi|fr|he|hr|hu|it|jp|ko|ko|lt|lt|lv|nl|no|pl|pl|pt|ro|ru|si|sk|sp|sv|tr|zh)$/)){
+
+								
+								lang = navigator.language.split('-')[0];
+							}
+							
+							
+							
+							if (!inputSupport.date) {
+								toLoad = toLoad.concat([  
+										  scriptDir + '../../shared/js/jscalendar-1.0/calendar-win2k-1.css',
+										  scriptDir + '../../shared/js/jscalendar-1.0/calendar.js', 
+										  scriptDir + '../../shared/js/jscalendar-1.0/lang/calendar-' + lang + '.js', 
+										  scriptDir + '../../shared/js/jscalendar-1.0/calendar-setup.js']);
+								loadHTML5Widgets = true;
+							}
+							break;
+							
+						case "output":
+							if(!supportsOutput()) {
+								
+								loadHTML5Widgets = true;
+							}
+							break;
+						
+						case "range":
+						   /* yepnope({
+						    	load: ['ie6!' + scriptDir + '../../shared/css/slider.css']
+						   }); */
+						    
+							if(!inputSupport.range) {
+								toLoad = toLoad.concat([  scriptDir + '../../shared/css/slider.css',
+										  scriptDir + '../../shared/js/frequency-decoder.com/slider.js']);
+							
+										  
+								loadHTML5Widgets = true;
+								toRunAfterLoad.push('fdSliderController.redrawAll');
+									 
+							}
+							break;
+						case "placeholder":
+						case "autofocus":
+							if (!Modernizr.input[supportReq]) {
+								loadHTML5Widgets = true;
+							}
+					}
+				}
+				
+				
+				if (toLoad.length == 0) {
+					loadWidgets();
+					
+					// allow browsers that don't need webforms2 to handle custom error messages populated
+					// in the data-errormessage attribute
+					if (document.addEventListener) {
+						document.addEventListener('DOMContentLoaded', handleCustomErrorMessages, false);
+					}
+				} else {
+					yepnope({
+						load: toLoad,
+						complete: function (){
+							loadWidgets();
+							handleCustomErrorMessages();
+						}
+					});
+				}
+			}
+		}
+		
+		function loadWidgets() {
+			
+			yepnope({
+				test: loadHTML5Widgets,
+				yep: scriptDir + '../../shared/js/html5Widgets.js',
+				complete: function () {
+					if (loadHTML5Widgets) {
+						for (var i=0; i<toRunAfterLoad.length; i++)  {
+							eval(toRunAfterLoad[i] + '()');
+						}
+						EventHelpers.init();
+						html5Widgets.init();
+						//toRunAfterLoad.push('html5Widgets.init');
+					}
+				}
+			})
+			
+		}
+		
+		/*
+		 * This should work even when webforms2 is not loaded.
+		 */
+		function handleCustomErrorMessages() {
+			
+			var nodeNames = ["input", "select", "textarea"];
+			for (var i=0; i<nodeNames.length; i++) {
+				var nodes = document.getElementsByTagName(nodeNames[i]);
+				
+				for (var j=0; j<nodes.length; j++) {
+					var node = nodes[j];
+					var message = me.getAttributeValue(node, 'data-errormessage');
+					if (message) {
+						if(document.addEventListener){
+							node.addEventListener('invalid', showCustomMessageEvent, false);
+							node.addEventListener('focus', showCustomMessageEvent, false);
+							
+							// Opera doesn't work well with this.
+							if (!window.opera) {
+								node.addEventListener('keypress', clearMessageIfValidEvent, false);
+							}
+							
+							node.addEventListener('input', clearMessageIfValidEvent, false);
+						} else {
+							var invalidEvent = ' this.setCustomValidity("' + message + '");';
+							if (node.oninvalid) {
+								node.oninvalid += invalidEvent;
+							} else {
+								node.oninvalid = invalidEvent;
+							}
+							node.oninvalid = new Function('event', node.oninvalid);
+							
+							// IE freaks a little on keypress here, so change to keydown.
+							node.attachEvent('onkeydown', clearMessageIfValidEvent);
+							node.attachEvent('oninput', clearMessageIfValidEvent); 
+						}
+						clearMessageIfValid(node);
+			
+					}
+				}
+			}
+		}
+		
+		function showCustomMessageEvent(event) {
+			var node = event.currentTarget || event.srcElement;
+			showCustomMessage(node);
+		}
+		
+		function showCustomMessage(node) {
+			if (node.validity.valid) {
+				return;
+			}
+			var message = me.getAttributeValue(node, 'data-errormessage');
+			node.setCustomValidity(message)
+			console.log('set custom validity')
+		}
+		
+		function clearMessageIfValidEvent (event) {
+			console.log(event.type)
+			var node = event.currentTarget || event.srcElement;
+			clearMessageIfValid(node);
+		}
+		
+		function clearMessageIfValid(node) {
+			node.setCustomValidity(''); 
+			if (!node.checkValidity()) {
+				showCustomMessage(node);
+				console.log('invalid')
+				if (document.addEventListener) {
+					globalEvent.initEvent('invalid', true, true); // event type,bubbling,cancelable
+	        		node.dispatchEvent(globalEvent);
+	        	}
+			} else {
+				console.log('valid')
+			}
+		}
+		
+	}
+	
+	var supportsOutput = function () {
+		var outputEl = document.createElement('output');
+		return (outputEl.value != undefined && (outputEl.onforminput !== undefined || outputEl.oninput !== undefined));
+		
+	}
+	
+	var getScriptDir = function () {
+		var arr = scriptNode.src.split('/');
+		arr.pop();
+		
+		return arr.join('/') + '/';
+	}
+	
+	me.getAttributeByName = function (obj, attrName) {
+		var i;
+		
+		var attributes = obj.attributes;
+		for (var i=0; i<attributes.length; i++) {
+			var attr = attributes[i]
+			if (attr.nodeName == attrName && attr.specified) {
+			  	return attr;
+			}
+		}
+		return null;
+	}
+	
+	me.getAttributeValue = function (obj, attrName) {
+		var attr = me.getAttributeByName(obj, attrName);
+		
+		if (attr != null) {
+			return attr.nodeValue;
+		} else {
+			return null;
+		}
+	}
+	
+	var initWhitespaceRe = /^\s\s*/;
+	var endWhitespaceRe = /\s\s*$/;
+	
+	function trim(str) {
+		return str.replace(initWhitespaceRe, '')
+			.replace(endWhitespaceRe, '');
+	}  
+
+}
+
+html5Forms.init();
